unit frameLinearChart;

interface

uses
   Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
   Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus,
   Vcl.Menus, VclTee.TeeTools,
   VclTee.TeeLegendScrollBar, VclTee.TeEngine, VclTee.Series, Vcl.StdCtrls, Vcl.ExtCtrls,
   VclTee.TeeProcs, VclTee.Chart, VclTee.TeeEdit;

type
   TfrLinearChart = class(TFrame)
      ChartEditor1: TChartEditor;
      TopLinearChart: TChart;
      Series1T_O: TLineSeries;
      Series1TF_O: TLineSeries;
      Series1T_U: TLineSeries;
      Series1TF_U: TLineSeries;
      SeriesClippedT_O: TLineSeries;
      SeriesClippedT_U: TLineSeries;
      Series2T_O: TLineSeries;
      Series2T_U: TLineSeries;
      Series3T_O: TLineSeries;
      Series3T_U: TLineSeries;
      Series4T_O: TLineSeries;
      Series4T_U: TLineSeries;
      Series5T_O: TPointSeries;
      Series5T_U: TPointSeries;
      Series6T_O: THorizBarSeries;
      Series6T_U: THorizBarSeries;
      Series7T_O: TLineSeries;
      Series7T_U: TLineSeries;
      Series8T_O: TLineSeries;
      Series8T_U: TLineSeries;
      Series9T_O: TLineSeries;
      Series9T_U: TLineSeries;
      Series10T_O: TLineSeries;
      Series10T_U: TLineSeries;
      Series11T_O: TPointSeries;
      Series11T_U: TPointSeries;
      Series12T_O: TLineSeries;
      Series12T_U: TLineSeries;
      Series13T_O: TLineSeries;
      Series13T_U: TLineSeries;
      Series23: TLineSeries;
      Series24: TPointSeries;
      Series25: TLineSeries;
      ChartTool1: TAxisScrollTool;
      ChartTool2: TAxisScrollTool;
      CursorTool3: TCursorTool;
      ChartTool4: TLegendScrollBar;
      ChartTool3: TFullScreenTool;
      BottomLinearChart: TChart;
      Series1B_O: TLineSeries;
      Series1BF_O: TLineSeries;
      Series1B_U: TLineSeries;
      Series1BF_U: TLineSeries;
      SeriesClippedB_O: TLineSeries;
      SeriesClippedB_U: TLineSeries;
      Series2B_O: TLineSeries;
      Series2B_U: TLineSeries;
      Series3B_O: TLineSeries;
      Series3B_U: TLineSeries;
      Series4B_O: TLineSeries;
      Series4B_U: TLineSeries;
      Series5B_O: TPointSeries;
      Series5B_U: TPointSeries;
      Series6B_O: THorizBarSeries;
      Series6B_U: THorizBarSeries;
      Series7B_O: TLineSeries;
      Series7B_U: TLineSeries;
      Series8B_O: TLineSeries;
      Series8B_U: TLineSeries;
      Series9B_O: TLineSeries;
      Series9B_U: TLineSeries;
      Series10B_O: TLineSeries;
      Series10B_U: TLineSeries;
      Series11B_O: TPointSeries;
      Series11B_U: TPointSeries;
      Series12B_O: TLineSeries;
      Series12B_U: TLineSeries;
      Series13B_O: TLineSeries;
      Series13B_U: TLineSeries;
      LineSeries23B: TLineSeries;
      PointSeries24B: TPointSeries;
      LineSeries25B: TLineSeries;
      AxisScrollTool3: TAxisScrollTool;
      AxisScrollTool4: TAxisScrollTool;
      CursorTool2: TCursorTool;
      ChartTool5: TLegendScrollBar;
      ChartTool6: TFullScreenTool;
      procedure TopLinearChartDblClick(Sender: TObject);
      procedure BottomLinearChartDblClick(Sender: TObject);
      procedure rgnChartsPropertiesChange(Sender: TObject);
      procedure btnFullscreenTopClick(Sender: TObject);
      procedure btnFullscreenBottomClick(Sender: TObject);
      procedure cbCursorTopClick(Sender: TObject);
      procedure cbCursorBottomClick(Sender: TObject);
   private
      sTitleTop, sTitleBottom: string;
      procedure ChartTool3Reset(Sender: TObject);
      procedure ChartTool6Reset(Sender: TObject);
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      procedure Autoscale;
   end;

implementation

{$R *.dfm}



procedure TfrLinearChart.BottomLinearChartDblClick(Sender: TObject);
begin
   ChartEditor1.Chart := BottomLinearChart;
   ChartEditor1.Series := BottomLinearChart.SeriesList[0];
   ChartEditor1.Execute;
end;


procedure TfrLinearChart.btnFullscreenBottomClick(Sender: TObject);
begin
   if ChartTool6.Active then begin
      ChartTool6.Active := false;
   end
   else begin
      ChartTool6.Active := true;
      sTitleBottom := BottomLinearChart.Title.Caption;
      BottomLinearChart.Title.Caption := 'back with ESC or click button';
      BottomLinearChart.Title.Font.Size := 14;
      BottomLinearChart.Title.Visible := true;
   end;
end;


procedure TfrLinearChart.ChartTool6Reset(Sender: TObject);
begin
   BottomLinearChart.Title.Font.Size := 8;
   BottomLinearChart.Title.Caption := sTitleBottom;
end;


procedure TfrLinearChart.btnFullscreenTopClick(Sender: TObject);
begin
   if ChartTool3.Active then begin
      ChartTool3.Active := false;
   end
   else begin
      ChartTool3.Active := true;
      sTitleTop := TopLinearChart.Title.Caption;
      TopLinearChart.Title.Caption := 'back with ESC or click button';
      TopLinearChart.Title.Font.Size := 14;
      TopLinearChart.Title.Visible := true;
   end;
end;


procedure TfrLinearChart.ChartTool3Reset(Sender: TObject);
begin
   TopLinearChart.Title.Font.Size := 8;
   TopLinearChart.Title.Caption := sTitleTop;
end;


// Cursor fr oberen Chart ein- ausschalten
procedure TfrLinearChart.cbCursorTopClick(Sender: TObject);
begin
//   CursorTool3.Visible := cbCursorTop.Checked;
end;


// Cursor fr unteren Chart ein- ausschalten
procedure TfrLinearChart.cbCursorBottomClick(Sender: TObject);
begin
//   CursorTool2.Visible := cbCursorBottom.Checked;
end;



procedure TfrLinearChart.rgnChartsPropertiesChange(Sender: TObject);
begin
   Autoscale;
end;


procedure TfrLinearChart.TopLinearChartDblClick(Sender: TObject);
begin
   ChartEditor1.Chart := TopLinearChart;
   ChartEditor1.Series := TopLinearChart.SeriesList[0];
   ChartEditor1.Execute;
end;


procedure TfrLinearChart.Autoscale;
var
   bb: boolean;
begin
//   if rgnCharts.ItemIndex = 0 then begin
//      TopLinearChart.Height := rgBottomAxis.Top - TopLinearChart.Top - 6;
//      BottomLinearChart.Visible := false;
//      rgShowSeparatedCurves.Enabled := false;
//      btnFullscreenTop.Left := TopLinearChart.Left + 2;
//      btnFullscreenTop.Top := TopLinearChart.Height - btnFullscreenTop.Height - 2;
//   end
//   else begin
//      TopLinearChart.Height := (rgBottomAxis.Top - TopLinearChart.Top - 6) div 2;
//      BottomLinearChart.Top := TopLinearChart.Top + TopLinearChart.Height + 2;
//      BottomLinearChart.Height := TopLinearChart.Height;
//      BottomLinearChart.Visible := true;
//      rgShowSeparatedCurves.Enabled := true;
//      btnFullscreenTop.Left := TopLinearChart.Left + 2;
//      btnFullscreenTop.Top := TopLinearChart.Height - btnFullscreenTop.Height - 2;
//      btnFullscreenBottom.Left := BottomLinearChart.Left + 2;
//      btnFullscreenBottom.Top := BottomLinearChart.Height - btnFullscreenBottom.Height - 2;
//   end;

   // wird nicht mehr bentigt, Reserve
   Series2T_O.Visible := false;
   Series2T_U.Visible := false;
   Series2B_O.Visible := false;
   Series2B_U.Visible := false;
   Series2T_O.ShowInLegend := false;
   Series2T_U.ShowInLegend := false;
   Series2B_O.ShowInLegend := false;
   Series2B_U.ShowInLegend := false;

   Series1T_U.ShowInLegend := not bb;
   Series1B_O.ShowInLegend := not bb;
   Series1TF_U.ShowInLegend := not bb;
   Series1BF_O.ShowInLegend := not bb;
   Series3T_U.ShowInLegend := not bb;
   Series3B_O.ShowInLegend := not bb;
   Series4T_U.ShowInLegend := not bb;
   Series4B_O.ShowInLegend := not bb;
   Series5T_U.ShowInLegend := not bb;
   Series5B_O.ShowInLegend := not bb;
   SeriesClippedT_U.ShowInLegend := not bb;
   SeriesClippedB_O.ShowInLegend := not bb;

   Series8T_U.ShowInLegend := not bb;
   Series8B_O.ShowInLegend := not bb;
   Series9T_U.ShowInLegend := not bb;
   Series9B_O.ShowInLegend := not bb;
   Series10T_U.ShowInLegend := not bb;
   Series10B_O.ShowInLegend := not bb;
   Series11T_U.ShowInLegend := not bb;
   Series11B_O.ShowInLegend := not bb;
   Series12T_U.ShowInLegend := not bb;
   Series12B_O.ShowInLegend := not bb;
   Series13T_U.ShowInLegend := not bb;
   Series13B_O.ShowInLegend := not bb;

end;


end.
